#extension GL_EXT_geometry_shader4: enable
#extension GL_EXT_gpu_shader4: enable

layout(max_vertices=255) out;

in vec4 vcolor[];
in vec2 geomTexCoord[];
out vec4 color;
out vec2 fragTexCoord;

const int instances = 6;

void main()
{
  int i,j,k;
  vec4 vertex;
  int rnd = 7;  //random seed
  float rnd_mov;
  
  //create X-instances of one object
  for(i = 0; i<instances; i++)
  {
    for(j = 0; j<instances; j++)
    {
      //pseudo-random generator
      rnd = (rnd*rnd + 1) % 8051;
      rnd_mov =  0.0004 * float(rnd);
      for(k = 0; k < 3; k++)
      {
          vertex = gl_PositionIn[k];
          vertex.x += j*7.0 - 3.5*instances + rnd_mov;
          vertex.y += 0.3*rnd_mov;
          vertex.z += i*7.0 - 3.5*instances + rnd_mov;

          gl_Position = gl_ModelViewProjectionMatrix * vertex;
          fragTexCoord = geomTexCoord[k];
          color = vcolor[k];
          EmitVertex();
      }
      EndPrimitive();
    }
  }
}
