
#extension GL_EXT_geometry_shader4: enable
#extension GL_EXT_gpu_shader4: enable   

out vec2 coord;

uniform float time;
//uniform int PARTICLES;

const float SPEED = 15.0;
const float EMITTER_HEIGHT = 10.0;

//Create rain particle
void MakeDrop(vec4 vertex)
{
    //create quad from point
    vertex.x += 0.2;
    gl_Position = gl_ModelViewProjectionMatrix * vertex;
    coord = vec2(0.0,0.0);
    EmitVertex();

    vertex.y += 0.4;
    gl_Position = gl_ModelViewProjectionMatrix * vertex;
    coord = vec2(1.0,0.0);
    EmitVertex();

    vertex.y -= 0.4;
    vertex.x -= 0.2;
    gl_Position = gl_ModelViewProjectionMatrix * vertex;
    coord = vec2(0.0,1.0);
    EmitVertex();

    vertex.y += 0.2;
    gl_Position = gl_ModelViewProjectionMatrix * vertex;
    coord = vec2(1.0,1.0);
    EmitVertex();

    EndPrimitive();
}

void main()
{
    int i,j,k;
    vec4 particle;
    int rnd = 3;  //random seed

    //generate X-particles around basic point
    for(i = 0; i<PARTICLES; i++)
    {
      for(j = 0; j<PARTICLES; j++)
      {
        //pseudo-random generator
        rnd = (rnd*rnd + 1) % 73;
        particle = gl_PositionIn[0];
        particle.x += i + float(rnd)*0.02 - PARTICLES*0.5;
        particle.z += j - float(rnd)*0.02 - PARTICLES*0.5;
        //various particle speed
        particle.y -= mod(time*(SPEED+float(rnd)), EMITTER_HEIGHT);
        MakeDrop(particle);
      }
    }
}
