// wwlk
//
// Trivial Vertex shader to setup per fragment lighting
//
/*
//vertex attributes
in vec3 in_Vertex;
in vec3 in_Normal;
in vec2 in_Coord;
*/

//vertex attributes
vec3 in_Vertex = gl_Vertex.xyz;
vec3 in_Normal = gl_Normal;
vec2 in_Coord = gl_MultiTexCoord0.st;

vec4 ULLight = vec4 ( 0.435028 , 0.602347 , 0.669274 , 0.0 );
vec4 LRLight = vec4 ( 0.894427 , 0.0      , 0.447214 , 0.0 );
vec4  RimLight = vec4( 0.94868, 0.0,  0.316228, 1.0 );

vec4  DifColor = vec4( 0.35, 0.35, 0.5, 1.0 );
vec4  SpecColor = vec4( 0.4, 0.4, 0.2, 1.0 );
vec4  ULColor = vec4( 0.5, 0.3875, 0.75, 1.0 );
vec4  LRColor = vec4( 0.75, 0.5, 0.5, 1.0 );


void main(void)
{ 
	vec3 eyeNormal;

	gl_Position = gl_ModelViewProjectionMatrix * vec4(in_Vertex,1.0);
	eyeNormal = vec3(gl_ModelViewMatrix * vec4(in_Normal,0.0));

    gl_TexCoord[0] = vec4( eyeNormal, 0.0 );

	gl_TexCoord[1] = ULLight;
	gl_TexCoord[2] = LRLight;
	gl_TexCoord[3] = RimLight;

	gl_TexCoord[4] = DifColor;
	gl_TexCoord[5] = SpecColor;
	gl_TexCoord[6] = ULColor;
	gl_TexCoord[7] = LRColor;

}
