
/*
//vertex attributes
in vec3 in_Vertex;
in vec3 in_Normal;
in vec2 in_Coord;
*/

//vertex attributes
vec3 in_Vertex = gl_Vertex.xyz;
vec3 in_Normal = gl_Normal;
vec2 in_Coord = gl_MultiTexCoord0.st;

out vec3 position, normal, lightDir, eyeVec;

void main()
{
  vec4 vertex = vec4(in_Vertex,1.0);
  normal = vec3(gl_ModelViewMatrix * vec4(in_Normal,0.0));                //surface normal
  vec3 vVertex = vec3(gl_ModelViewMatrix * vertex); //view vector
  lightDir = vec3(gl_LightSource[0].position.xyz - vVertex); 
  eyeVec = -vVertex;                 //eyeview position
  position = vertex.xyz;
  gl_Position = gl_ModelViewProjectionMatrix * vertex;
} 
