
/*
//vertex attributes
in vec3 in_Vertex;
in vec3 in_Normal;
in vec2 in_Coord;
*/

//built-in vertex attributes
vec3 in_Vertex = gl_Vertex.xyz;
vec3 in_Normal = gl_Normal;

out vec3 normal, eyeVec;

void main()
{
    vec4 vertex = vec4(in_Vertex,1.0);
	gl_Position = gl_ModelViewProjectionMatrix * vertex;

    mat3 tcamerarot;
    tcamerarot[0][0] = gl_ModelViewMatrixTranspose[0][0];
	tcamerarot[0][1] = gl_ModelViewMatrixTranspose[0][1];
	tcamerarot[0][2] = gl_ModelViewMatrixTranspose[0][2];

	tcamerarot[1][0] = gl_ModelViewMatrixTranspose[1][0];
	tcamerarot[1][1] = gl_ModelViewMatrixTranspose[1][1];
	tcamerarot[1][2] = gl_ModelViewMatrixTranspose[1][2];

	tcamerarot[2][0] = gl_ModelViewMatrixTranspose[2][0];
	tcamerarot[2][1] = gl_ModelViewMatrixTranspose[2][1];
	tcamerarot[2][2] = gl_ModelViewMatrixTranspose[2][2];

    normal = tcamerarot * (gl_NormalMatrix * in_Normal);
    eyeVec = tcamerarot * (gl_ModelViewMatrix * vertex).xyz;
}
