//Material: "mat_wet"

/*
//vertex attributes
in vec3 in_Vertex;
in vec3 in_Normal;
in vec2 in_Coord;
*/

//built-in vertex attributes
vec3 in_Vertex = gl_Vertex.xyz;
vec3 in_Normal = gl_Normal;
vec2 in_Coord = gl_MultiTexCoord0.st;

out vec3 normal, eyeVec;
out vec2 fragTexCoord;

void main()
{
  vec4 vertex = vec4(in_Vertex, 1.0);
  normal = gl_NormalMatrix * in_Normal;                //surface normal
  eyeVec = -vec3(gl_ModelViewMatrix * vertex); //view vector
  fragTexCoord = in_Coord;
  gl_Position = gl_ModelViewProjectionMatrix * vertex;      //vertex transform
}

