///-----------------------------------------------------------------
///
/// @file      gui2.cpp
/// @author    Juraj Vanek
/// Created:   15. 4. 2010 23:44:06
/// @section   DESCRIPTION
///            TForm class implementation
///
///------------------------------------------------------------------

#include "gui.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
#include "Images/Self_TForm_XPM.xpm"
////Header Include End

//----------------------------------------------------------------------------
// TForm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(TForm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(TForm::OnClose)
	EVT_BUTTON(ID_BTNDEMO,TForm::btnDemoClick)
	EVT_BUTTON(ID_BTNABOUT,TForm::btnAboutClick)
	EVT_BUTTON(ID_BTNHELP,TForm::btnHelpClick)
	EVT_BUTTON(ID_BTNRUN,TForm::btnRunClick)
	EVT_BUTTON(ID_BTNSCORE,TForm::btnScoreClick)
	EVT_BUTTON(ID_BTNINFO,TForm::btnInfoClick)
	EVT_BUTTON(ID_BTNCHANGE,TForm::btnChangeClick)
	EVT_CHOICE(ID_CHOICEPRESET,TForm::choicePresetSelected)
END_EVENT_TABLE()
////Event Table End

TForm::TForm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
	SetBackgroundColour(wxColour(250,255,255));	
	
	//settings dialog
	changeDialog = new ChangeDialog(this);
	//HTML info
	sysInfo = new TInfo(this);
  
  //startup settings
  resx = wxT("1280");
  resy = wxT("720");
  aa = wxT("4x");
  test_series = wxT("all");	
  screen_mode = wxT(" -f ");
  
  //Get system info
  ParseSystemInfo();
}

TForm::~TForm()
{
}

void TForm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	mainSizer = new wxBoxSizer(wxVERTICAL);
	this->SetSizer(mainSizer);
	this->SetAutoLayout(true);

	topLayout = new wxBoxSizer(wxHORIZONTAL);
	mainSizer->Add(topLayout, 0, wxALIGN_CENTER | wxALL, 5);

	wxStaticBox* leftLayout_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT(""));
	leftLayout = new wxStaticBoxSizer(leftLayout_StaticBoxObj, wxVERTICAL);
	topLayout->Add(leftLayout, 0, wxALIGN_CENTER | wxEXPAND | wxALL, 5);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Benchmark settings"), wxPoint(37, 20), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetForegroundColour(wxColour(0,128,128));
	WxStaticText1->SetFont(wxFont(11, wxSWISS, wxNORMAL, wxNORMAL, false, wxT("Segoe UI Semibold")));
	leftLayout->Add(WxStaticText1,0,wxALIGN_CENTER | wxALL,5);

	WxFlexGridSizer1 = new wxFlexGridSizer(0, 2, 0, 0);
	leftLayout->Add(WxFlexGridSizer1, 1, wxALIGN_RIGHT | wxEXPAND | wxALL, 5);

	WxStaticText6 = new wxStaticText(this, ID_WXSTATICTEXT6, wxT("Preset:"), wxPoint(19, 7), wxDefaultSize, 0, wxT("WxStaticText6"));
	WxStaticText6->SetFont(wxFont(9, wxSWISS, wxNORMAL, wxBOLD, false));
	WxFlexGridSizer1->Add(WxStaticText6,0,wxALIGN_RIGHT | wxALL,5);

	wxArrayString arrayStringFor_choicePreset;
	arrayStringFor_choicePreset.Add(wxT("Low-end"));
	arrayStringFor_choicePreset.Add(wxT("Mainstream"));
	arrayStringFor_choicePreset.Add(wxT("High-end"));
	arrayStringFor_choicePreset.Add(wxT("Custom"));
	choicePreset = new wxChoice(this, ID_CHOICEPRESET, wxPoint(86, 5), wxSize(110, 23), arrayStringFor_choicePreset, 0, wxDefaultValidator, wxT("choicePreset"));
	choicePreset->SetBackgroundColour(wxColour(250,255,255));
	choicePreset->SetFont(wxFont(9, wxSWISS, wxNORMAL, wxBOLD, false));
	choicePreset->SetSelection(1);
	WxFlexGridSizer1->Add(choicePreset,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("Resolution:"), wxPoint(9, 38), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxFlexGridSizer1->Add(WxStaticText3,0,wxALIGN_RIGHT | wxALL,5);

	textResolution = new wxStaticText(this, ID_TEXTRESOLUTION, wxT("1280x720"), wxPoint(115, 38), wxDefaultSize, 0, wxT("textResolution"));
	WxFlexGridSizer1->Add(textResolution,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("AntiAliasing:"), wxPoint(5, 67), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxFlexGridSizer1->Add(WxStaticText4,0,wxALIGN_RIGHT | wxALL,5);

	textAA = new wxStaticText(this, ID_TEXTAA, wxT("4x"), wxPoint(133, 67), wxDefaultSize, 0, wxT("textAA"));
	WxFlexGridSizer1->Add(textAA,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText5 = new wxStaticText(this, ID_WXSTATICTEXT5, wxT("Test series:"), wxPoint(10, 96), wxDefaultSize, 0, wxT("WxStaticText5"));
	WxFlexGridSizer1->Add(WxStaticText5,0,wxALIGN_RIGHT | wxALL,5);

	textSeries = new wxStaticText(this, ID_TEXTSERIES, wxT("All"), wxPoint(132, 96), wxDefaultSize, 0, wxT("textSeries"));
	WxFlexGridSizer1->Add(textSeries,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText10 = new wxStaticText(this, ID_WXSTATICTEXT10, wxT("Run time:"), wxPoint(13, 125), wxDefaultSize, 0, wxT("WxStaticText10"));
	WxFlexGridSizer1->Add(WxStaticText10,0,wxALIGN_RIGHT | wxALL,5);

	textRuntime = new wxStaticText(this, ID_TEXTRUNTIME, wxT("8m 30s"), wxPoint(120, 125), wxDefaultSize, 0, wxT("textRuntime"));
	WxFlexGridSizer1->Add(textRuntime,0,wxALIGN_CENTER | wxALL,5);

	btnChange = new wxButton(this, ID_BTNCHANGE, wxT("Change"), wxPoint(68, 203), wxSize(75, 25), 0, wxDefaultValidator, wxT("btnChange"));
	btnChange->Enable(false);
	leftLayout->Add(btnChange,0,wxALIGN_CENTER | wxALL,5);

	wxStaticBox* rightLayout_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT(""));
	rightLayout = new wxStaticBoxSizer(rightLayout_StaticBoxObj, wxVERTICAL);
	topLayout->Add(rightLayout, 0, wxALIGN_CENTER | wxEXPAND | wxALL, 5);

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("System info"), wxPoint(86, 20), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->SetForegroundColour(wxColour(0,128,128));
	WxStaticText2->SetFont(wxFont(11, wxSWISS, wxNORMAL, wxNORMAL, false, wxT("Segoe UI Semibold")));
	rightLayout->Add(WxStaticText2,0,wxALIGN_CENTER | wxALL,5);

	WxFlexGridSizer2 = new wxFlexGridSizer(0, 2, 0, 0);
	rightLayout->Add(WxFlexGridSizer2, 1, wxALIGN_CENTER | wxEXPAND | wxALL, 5);

	WxStaticText7 = new wxStaticText(this, ID_WXSTATICTEXT7, wxT("GFX:"), wxPoint(16, 8), wxDefaultSize, 0, wxT("WxStaticText7"));
	WxFlexGridSizer2->Add(WxStaticText7,0,wxALIGN_RIGHT | wxALL,5);

	textGFX = new wxStaticText(this, ID_TEXTGFX, wxT("N/A"), wxPoint(65, 5), wxSize(175, 26), wxST_NO_AUTORESIZE, wxT("textGFX"));
	WxFlexGridSizer2->Add(textGFX,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText9 = new wxStaticText(this, ID_WXSTATICTEXT9, wxT("CPU:"), wxPoint(15, 44), wxDefaultSize, 0, wxT("WxStaticText9"));
	WxFlexGridSizer2->Add(WxStaticText9,0,wxALIGN_RIGHT | wxALL,5);

	textCPU = new wxStaticText(this, ID_TEXTCPU, wxT("N/A"), wxPoint(65, 41), wxSize(175, 26), wxST_NO_AUTORESIZE, wxT("textCPU"));
	WxFlexGridSizer2->Add(textCPU,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText11 = new wxStaticText(this, ID_WXSTATICTEXT11, wxT("OS:"), wxPoint(19, 80), wxDefaultSize, 0, wxT("WxStaticText11"));
	WxFlexGridSizer2->Add(WxStaticText11,0,wxALIGN_RIGHT | wxALL,5);

	textOS = new wxStaticText(this, ID_TEXTOS, wxT("N/A"), wxPoint(65, 77), wxSize(175, 26), wxST_NO_AUTORESIZE, wxT("textOS"));
	WxFlexGridSizer2->Add(textOS,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText8 = new wxStaticText(this, ID_WXSTATICTEXT8, wxT("OpenGL:"), wxPoint(5, 116), wxDefaultSize, 0, wxT("WxStaticText8"));
	WxFlexGridSizer2->Add(WxStaticText8,0,wxALIGN_RIGHT | wxALL,5);

	textOGL = new wxStaticText(this, ID_TEXTOGL, wxT("N/A"), wxPoint(65, 113), wxSize(175, 26), wxST_NO_AUTORESIZE, wxT("textOGL"));
	WxFlexGridSizer2->Add(textOGL,0,wxALIGN_CENTER | wxALL,5);

	btnInfo = new wxButton(this, ID_BTNINFO, wxT("More info"), wxPoint(90, 198), wxSize(75, 25), 0, wxDefaultValidator, wxT("btnInfo"));
	rightLayout->Add(btnInfo,0,wxALIGN_CENTER | wxALL,5);

	wxStaticBox* WxStaticBoxSizer1_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT(""));
	WxStaticBoxSizer1 = new wxStaticBoxSizer(WxStaticBoxSizer1_StaticBoxObj, wxVERTICAL);
	topLayout->Add(WxStaticBoxSizer1, 0, wxALIGN_CENTER | wxEXPAND | wxALL, 5);

	WxStaticText12 = new wxStaticText(this, ID_WXSTATICTEXT12, wxT("Results"), wxPoint(118, 20), wxDefaultSize, 0, wxT("WxStaticText12"));
	WxStaticText12->SetForegroundColour(wxColour(0,128,128));
	WxStaticText12->SetFont(wxFont(11, wxSWISS, wxNORMAL, wxNORMAL, false, wxT("Segoe UI Semibold")));
	WxStaticBoxSizer1->Add(WxStaticText12,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText18 = new wxStaticText(this, ID_WXSTATICTEXT18, wxT("Partial scores:"), wxPoint(103, 54), wxDefaultSize, 0, wxT("WxStaticText18"));
	WxStaticText18->SetFont(wxFont(9, wxSWISS, wxNORMAL, wxBOLD, false));
	WxStaticBoxSizer1->Add(WxStaticText18,0,wxALIGN_CENTER | wxALL,5);

	WxFlexGridSizer3 = new wxFlexGridSizer(0, 4, 0, 0);
	WxStaticBoxSizer1->Add(WxFlexGridSizer3, 1, wxALIGN_CENTER | wxEXPAND | wxALL, 5);

	WxStaticText13 = new wxStaticText(this, ID_WXSTATICTEXT13, wxT("Fillrate:"), wxPoint(35, 5), wxDefaultSize, 0, wxT("WxStaticText13"));
	WxFlexGridSizer3->Add(WxStaticText13,0,wxALIGN_RIGHT | wxALL,5);

	textFillScore = new wxStaticText(this, ID_TEXTFILLSCORE, wxT("N/A"), wxPoint(117, 5), wxDefaultSize, 0, wxT("textFillScore"));
	WxFlexGridSizer3->Add(textFillScore,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText19 = new wxStaticText(this, ID_WXSTATICTEXT19, wxT("Vertex shaders:"), wxPoint(153, 5), wxDefaultSize, 0, wxT("WxStaticText19"));
	WxFlexGridSizer3->Add(WxStaticText19,0,wxALIGN_RIGHT | wxALL,5);

	textVertScore = new wxStaticText(this, ID_TEXTVERTSCORE, wxT("N/A"), wxPoint(246, 5), wxDefaultSize, 0, wxT("textVertScore"));
	WxFlexGridSizer3->Add(textVertScore,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText15 = new wxStaticText(this, ID_WXSTATICTEXT15, wxT("Fragment shaders:"), wxPoint(5, 34), wxDefaultSize, 0, wxT("WxStaticText15"));
	WxFlexGridSizer3->Add(WxStaticText15,0,wxALIGN_RIGHT | wxALL,5);

	textFragScore = new wxStaticText(this, ID_TEXTFRAGSCORE, wxT("N/A"), wxPoint(117, 34), wxDefaultSize, 0, wxT("textFragScore"));
	WxFlexGridSizer3->Add(textFragScore,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText21 = new wxStaticText(this, ID_WXSTATICTEXT21, wxT("HDR/Complex:"), wxPoint(153, 34), wxDefaultSize, 0, wxT("WxStaticText21"));
	WxFlexGridSizer3->Add(WxStaticText21,0,wxALIGN_RIGHT | wxALL,5);

	textCplxScore = new wxStaticText(this, ID_TEXTCPLXSCORE, wxT("N/A"), wxPoint(246, 34), wxDefaultSize, 0, wxT("textCplxScore"));
	WxFlexGridSizer3->Add(textCplxScore,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText17 = new wxStaticText(this, ID_WXSTATICTEXT17, wxT("Geometry shaders:"), wxPoint(5, 63), wxDefaultSize, 0, wxT("WxStaticText17"));
	WxFlexGridSizer3->Add(WxStaticText17,0,wxALIGN_RIGHT | wxALL,5);

	textGeomScore = new wxStaticText(this, ID_TEXTGEOMSCORE, wxT("N/A"), wxPoint(117, 63), wxDefaultSize, 0, wxT("textGeomScore"));
	WxFlexGridSizer3->Add(textGeomScore,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText23 = new wxStaticText(this, ID_WXSTATICTEXT23, wxT("Compute:"), wxPoint(166, 63), wxDefaultSize, 0, wxT("WxStaticText23"));
	WxFlexGridSizer3->Add(WxStaticText23,0,wxALIGN_RIGHT | wxALL,5);

	textCompScore = new wxStaticText(this, ID_TEXTCOMPSCORE, wxT("N/A"), wxPoint(246, 63), wxDefaultSize, 0, wxT("textCompScore"));
	WxFlexGridSizer3->Add(textCompScore,0,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer1->Add(WxBoxSizer1, 0, wxALIGN_CENTER | wxALL, 5);

	WxStaticText14 = new wxStaticText(this, ID_WXSTATICTEXT14, wxT("TOTAL SCORE:"), wxPoint(5, 5), wxDefaultSize, 0, wxT("WxStaticText14"));
	WxStaticText14->SetFont(wxFont(11, wxSWISS, wxNORMAL, wxBOLD, false));
	WxBoxSizer1->Add(WxStaticText14,0,wxALIGN_CENTER | wxALL,5);

	txtTotScore = new wxStaticText(this, ID_TXTTOTSCORE, wxT("N/A"), wxPoint(121, 5), wxDefaultSize, 0, wxT("txtTotScore"));
	txtTotScore->SetFont(wxFont(11, wxSWISS, wxNORMAL, wxBOLD, false));
	WxBoxSizer1->Add(txtTotScore,0,wxALIGN_CENTER | wxALL,5);

	btnScore = new wxButton(this, ID_BTNSCORE, wxT("View detail results"), wxPoint(78, 204), wxSize(131, 25), 0, wxDefaultValidator, wxT("btnScore"));
	btnScore->Enable(false);
	WxStaticBoxSizer1->Add(btnScore,0,wxALIGN_CENTER | wxALL,5);

	bottomLayout = new wxBoxSizer(wxHORIZONTAL);
	mainSizer->Add(bottomLayout, 0, wxALIGN_CENTER | wxALL, 5);

	btnRun = new wxButton(this, ID_BTNRUN, wxT("RUN!"), wxPoint(5, 5), wxSize(100, 30), 0, wxDefaultValidator, wxT("btnRun"));
	btnRun->SetFont(wxFont(9, wxSWISS, wxNORMAL, wxBOLD, false));
	bottomLayout->Add(btnRun,0,wxALIGN_CENTER | wxALL,5);

	btnHelp = new wxButton(this, ID_BTNHELP, wxT("Help"), wxPoint(115, 5), wxSize(100, 30), 0, wxDefaultValidator, wxT("btnHelp"));
	bottomLayout->Add(btnHelp,0,wxALIGN_CENTER | wxALL,5);

	btnAbout = new wxButton(this, ID_BTNABOUT, wxT("About"), wxPoint(225, 5), wxSize(100, 30), 0, wxDefaultValidator, wxT("btnAbout"));
	bottomLayout->Add(btnAbout,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText16 = new wxStaticText(this, ID_WXSTATICTEXT16, wxT("Please end all running application before test run"), wxPoint(265, 314), wxDefaultSize, 0, wxT("WxStaticText16"));
	WxStaticText16->SetFont(wxFont(9, wxSWISS, wxITALIC, wxNORMAL, false));
	mainSizer->Add(WxStaticText16,0,wxALIGN_CENTER | wxALL,5);

	btnDemo = new wxButton(this, ID_BTNDEMO, wxT("Run DEMO"), wxPoint(335, 5), wxSize(100, 30), 0, wxDefaultValidator, wxT("btnDemo"));
	bottomLayout->Add(btnDemo,0,wxALIGN_CENTER | wxALL,5);

	SetTitle(wxT("gluxMark 2"));
	SetIcon(Self_TForm_XPM);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
}

void TForm::OnClose(wxCloseEvent& event)
{
	Destroy();
}

/*
 * Update settings
 */
void TForm::UpdateSettings(wxString _resx, wxString _resy, wxString _aa, wxString _test_series, bool window)
{
  resx = _resx;
  resy = _resy;
  if(_aa == wxT("Off"))
    aa = wxT("0");
  else
    aa = _aa[0];
    
  if(window)
    screen_mode = wxT(" -w ");
  else
    screen_mode = wxT(" -f ");  
  
  if(_test_series == wxT("All tests"))
  {
    test_series = wxT("all");
    textRuntime->SetLabel(wxT("8m 30s"));
  }
  else if(_test_series == wxT("Fillrate"))
  {
    test_series = wxT("fillrate");
    textRuntime->SetLabel(wxT("0m 45s"));
  }    
  else if(_test_series == wxT("Fragment shaders"))
  {
    test_series = wxT("fragment");
    textRuntime->SetLabel(wxT("2m 00s"));
  }    
  else if(_test_series == wxT("Geometry shaders"))
  {
    test_series = wxT("geometry");
    textRuntime->SetLabel(wxT("1m 30s"));
  }    
  else if(_test_series == wxT("Vertex shaders"))
  {
    test_series = wxT("vertex");
    textRuntime->SetLabel(wxT("1m 20s"));
  }    
  else if(_test_series == wxT("Complex tests"))
  {
    test_series = wxT("complex");       
    textRuntime->SetLabel(wxT("2m 30s"));
  }             
  else if(_test_series == wxT("Compute tests"))
  {
    test_series = wxT("compute");   
    textRuntime->SetLabel(wxT("0m 20s"));
  }    
  
  textResolution->SetLabel(resx + wxT("x") + resy);
  textAA->SetLabel(aa + wxT("x"));
  textSeries->SetLabel(_test_series);
  
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
}

/*
 * Show settings dialog
 */
void TForm::btnChangeClick(wxCommandEvent& event)
{
	changeDialog->ShowModal();
}

/*
 * Select preset
 */
void TForm::choicePresetSelected(wxCommandEvent& event )
{
	//if set to custom, allow settings change
	wxString preset = event.GetString();
	if(preset == wxT("Custom"))
	{
	  btnChange->Enable();
	  return;
  }
	else
	 btnChange->Disable();
	 
	//change settings according to preset
	if(preset == wxT("Low-end"))
    UpdateSettings(wxT("1024"),wxT("768"),wxT("Off"),wxT("All tests"));
	else if(preset == wxT("Mainstream"))
    UpdateSettings(wxT("1280"),wxT("720"),wxT("4x"),wxT("All tests"));
	else if(preset == wxT("High-end"))
    UpdateSettings(wxT("1920"),wxT("1080"),wxT("8x"),wxT("All tests"));    	
	
}

/*
 * Start tests
 */
void TForm::btnRunClick(wxCommandEvent& event)
{
  long ret_code;      //return code
  
  //execute main application
  ret_code = wxExecute(app_exec + wxT(" -t ") + test_series + screen_mode + resx + wxT(" ") + resy + wxT(" -aa ") + aa, wxEXEC_SYNC);
  
  Raise();

  //if run was succesfull, parse results
  if(ret_code == 0)
  {
    if(ParseResults())
      btnScore->Enable();
  }
  else
    wxMessageBox(wxT("Test run failed!"),wxT(":("),wxICON_ERROR);
}

/*
 * Help - navigate user to web page
 */
void TForm::btnHelpClick(wxCommandEvent& event)
{
	wxLaunchDefaultBrowser(wxT("http://www.stud.fit.vutbr.cz/~xvanek29/gluxmark2"));
}

/*
 * About
 */
void TForm::btnAboutClick(wxCommandEvent& event)
{
	wxMessageBox(wxT("gluxMark 2 - performance evaluation of graphics accelerator\n"
               "Master's thesis, FIT VUT Brno 2010\n"
               "Created by Bc. Juraj Vanek"));
}

/*
 * Show system info
 */
void TForm::btnInfoClick(wxCommandEvent& event)
{
	sysInfo->ShowModal();
}

/*
 * Generate and show HTML page with results
 */
void TForm::btnScoreClick(wxCommandEvent& event)
{
  ParseResults();
  
  //path to results file
  wxString path = wxT("file://") + wxGetCwd(); 
#ifdef _WIN_        //rozlicne cesty k adresarom vo Windowse a Linuxe
  path += wxT("\\results.html");
#else
  path +=  wxT("/results.html");
#endif	  
  wxLaunchDefaultBrowser(path);
}

/*
 * Run demo executable
 */
void TForm::btnDemoClick(wxCommandEvent& event)
{
	wxExecute("gluxDemo.exe" + screen_mode + resx + wxT(" ") + resy + wxT(" -aa ") + aa, wxEXEC_SYNC);
}

