///-----------------------------------------------------------------
///
/// @file      gui2.h
/// @author    Juraj Vanek
/// Created:   15. 4. 2010 23:44:06
/// @section   DESCRIPTION
///            TForm class declaration
///
///------------------------------------------------------------------

#ifndef __TFORM_H__
#define __TFORM_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

#if defined (__WIN32__) || defined(_WIN32) || defined(__CYGWIN__)
  #define _WIN_
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/button.h>
#include <wx/choice.h>
#include <wx/stattext.h>
#include <wx/sizer.h>
////Header Include End
#include <wx/xml/xml.h>
#include <wx/file.h>
#include "change_dialog.h"
#include "sysinfo_dialog.h"

class ChangeDialog;

////Dialog Style Start
#undef TForm_STYLE
#define TForm_STYLE wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class TForm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		TForm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("gluxMark 2"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = TForm_STYLE);
		virtual ~TForm();
		void btnRunClick(wxCommandEvent& event);
		void btnChangeClick(wxCommandEvent& event);
		void choicePresetSelected(wxCommandEvent& event );
		
		void UpdateSettings(wxString _resx, wxString _resy, wxString _aa, wxString _test_series, bool window = false);
		bool ParseSystemInfo();
		bool ParseResults();
		
		void btnHelpClick(wxCommandEvent& event);
		void btnAboutClick(wxCommandEvent& event);
		void btnScoreClick(wxCommandEvent& event);
		void btnInfoClick(wxCommandEvent& event);
		void btnDemoClick(wxCommandEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxButton *btnDemo;
		wxStaticText *WxStaticText16;
		wxButton *btnAbout;
		wxButton *btnHelp;
		wxButton *btnRun;
		wxBoxSizer *bottomLayout;
		wxButton *btnScore;
		wxStaticText *txtTotScore;
		wxStaticText *WxStaticText14;
		wxBoxSizer *WxBoxSizer1;
		wxStaticText *textCompScore;
		wxStaticText *WxStaticText23;
		wxStaticText *textGeomScore;
		wxStaticText *WxStaticText17;
		wxStaticText *textCplxScore;
		wxStaticText *WxStaticText21;
		wxStaticText *textFragScore;
		wxStaticText *WxStaticText15;
		wxStaticText *textVertScore;
		wxStaticText *WxStaticText19;
		wxStaticText *textFillScore;
		wxStaticText *WxStaticText13;
		wxFlexGridSizer *WxFlexGridSizer3;
		wxStaticText *WxStaticText18;
		wxStaticText *WxStaticText12;
		wxStaticBoxSizer *WxStaticBoxSizer1;
		wxButton *btnInfo;
		wxStaticText *textOGL;
		wxStaticText *WxStaticText8;
		wxStaticText *textOS;
		wxStaticText *WxStaticText11;
		wxStaticText *textCPU;
		wxStaticText *WxStaticText9;
		wxStaticText *textGFX;
		wxStaticText *WxStaticText7;
		wxFlexGridSizer *WxFlexGridSizer2;
		wxStaticText *WxStaticText2;
		wxStaticBoxSizer *rightLayout;
		wxButton *btnChange;
		wxStaticText *textRuntime;
		wxStaticText *WxStaticText10;
		wxStaticText *textSeries;
		wxStaticText *WxStaticText5;
		wxStaticText *textAA;
		wxStaticText *WxStaticText4;
		wxStaticText *textResolution;
		wxStaticText *WxStaticText3;
		wxChoice *choicePreset;
		wxStaticText *WxStaticText6;
		wxFlexGridSizer *WxFlexGridSizer1;
		wxStaticText *WxStaticText1;
		wxStaticBoxSizer *leftLayout;
		wxBoxSizer *topLayout;
		wxBoxSizer *mainSizer;
		////GUI Control Declaration End
		
		//change settings dialog
		ChangeDialog *changeDialog;
		//HTML window with info
		TInfo *sysInfo;
    wxString sysInfoHTML;
		//benchmark settings
		wxString resx, resy, aa, test_series, screen_mode;
		//do we ahve OpenCL drivers installed?
		bool CLsupport, GSsupport;
		wxString app_exec;
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_BTNDEMO = 1071,
			ID_WXSTATICTEXT16 = 1069,
			ID_BTNABOUT = 1061,
			ID_BTNHELP = 1044,
			ID_BTNRUN = 1042,
			ID_BTNSCORE = 1060,
			ID_TXTTOTSCORE = 1068,
			ID_WXSTATICTEXT14 = 1067,
			ID_TEXTCOMPSCORE = 1059,
			ID_WXSTATICTEXT23 = 1058,
			ID_TEXTGEOMSCORE = 1053,
			ID_WXSTATICTEXT17 = 1052,
			ID_TEXTCPLXSCORE = 1057,
			ID_WXSTATICTEXT21 = 1056,
			ID_TEXTFRAGSCORE = 1051,
			ID_WXSTATICTEXT15 = 1050,
			ID_TEXTVERTSCORE = 1055,
			ID_WXSTATICTEXT19 = 1054,
			ID_TEXTFILLSCORE = 1049,
			ID_WXSTATICTEXT13 = 1048,
			ID_WXSTATICTEXT18 = 1070,
			ID_WXSTATICTEXT12 = 1046,
			ID_BTNINFO = 1030,
			ID_TEXTOGL = 1029,
			ID_WXSTATICTEXT8 = 1028,
			ID_TEXTOS = 1027,
			ID_WXSTATICTEXT11 = 1026,
			ID_TEXTCPU = 1025,
			ID_WXSTATICTEXT9 = 1024,
			ID_TEXTGFX = 1022,
			ID_WXSTATICTEXT7 = 1021,
			ID_WXSTATICTEXT2 = 1007,
			ID_BTNCHANGE = 1019,
			ID_TEXTRUNTIME = 1038,
			ID_WXSTATICTEXT10 = 1037,
			ID_TEXTSERIES = 1015,
			ID_WXSTATICTEXT5 = 1014,
			ID_TEXTAA = 1013,
			ID_WXSTATICTEXT4 = 1011,
			ID_TEXTRESOLUTION = 1010,
			ID_WXSTATICTEXT3 = 1009,
			ID_CHOICEPRESET = 1064,
			ID_WXSTATICTEXT6 = 1017,
			ID_WXSTATICTEXT1 = 1006,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
